local AddonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary2

a.Rotations = {}
c.RegisterForEvents(AddonName, a)
s.Spam[AddonName] = function()
    c.Flash(AddonName, a)
end

a.Rotations.Discipline = {
    Spec = 1,
    OffSwitch = "disc_off",
    
    FlashInCombat = function()
        a.FlashAll(
            "Prayer of Mending",
            "Free Flash Heal",
            "Shadowfiend for Mana",
--            "Pennance",
            "Inner Focus",
            "Power Word: Shield",
            "Binding Heal")
    end,
    
    FlashAlways = function()
        a.FlashAll(
            "Power Word: Fortitude",
            "Shadow Protection",
            "Inner Fire unless Inner Will", 
            "Inner Will unless Inner Fire")
    end,
    
    CastSucceeded = function(spellID, target)
        if spellID == c.GetID("Prayer of Mending") then
            a.PrayerOfMendingTarget = target
            c.Debug("Event", "Prayer of Mending target:", target)
        end
    end,
}

a.Rotations.Holy = {
    Spec = 2,
    OffSwitch = "holy_off",
    
    FlashInCombat = function()
        a.FlashAll(
            "Prayer of Mending",
            "Free Flash Heal",
            "Shadowfiend for Mana",
            "Lightwell",
            "Greater Heal under Serendipity",
            "Prayer of Healing under Serendipity",
            "Binding Heal",
            "Holy Word: Chastise",
            "Holy Word: Serenity",
            "Holy Word: Sanctuary")
    end,
    
    FlashAlways = function()
        a.FlashAll(
            "Power Word: Fortitude",
            "Shadow Protection",
            "Inner Fire unless Inner Will", 
            "Inner Will unless Inner Fire",
            "Chakra")
    end,
    
    CastSucceeded = function(spellID, target)
        if spellID == c.GetID("Prayer of Mending") then
            a.PrayerOfMendingTarget = target
            c.Debug("Event", "Prayer of Mending target:", target)
        end
    end,
}

a.Rotations.Shadow = {
    Spec = 3,
    OffSwitch = "shadow_off",
    
    FlashInCombat = function()
        a.Flash(
            "Shadow Word: Pain",
            "Mind Blast for Empowered Shadow",
            "Mind Flay for Empowered Shadow",
            "Mind Blast at 3 Orbs",
            "Mind Flay for Dark Evangelism",
            "Vampiric Touch",
            "Devouring Plague",
            "Dark Archangel",
            "Mind Blast",
            "Shadow Word: Death",
            "Shadowfiend",
            "Mind Flay")
    end,
    
    FlashOutOfCombat = function()
        a.Flash("Dispursion")
    end,
    
    FlashAlways = function()
        a.FlashAll(
            "Power Word: Fortitude",
            "Shadow Protection",
            "Shadowform", 
            "Inner Fire", 
            "Vampiric Embrace")
    end,
}
